Программный код 

1.	Программный код системы климат-контроля
#include "DHT.h"
#define DHTPIN 7     // вывод, к которому подключается датчик
#define DHTTYPE DHT22  // DHT 22  (AM2302)
#define Relay2  8 // включает лампу, если температура ниже контрольной
#define Relay1  9 // включает вентилятор, если температура превышает контрольную
int maxTemp = 29;
unsigned int sensorValue = 0;// начальные значения

DHT dht(DHTPIN, DHTTYPE);
 
void setup() {
  pinMode(Relay2, OUTPUT);
  pinMode(Relay1, OUTPUT);
  Serial.begin(9600); 
  dht.begin();
}
 
void loop() {
  // ждем пару секунд перед началом измерений
  delay(2000);
  float h = dht.readHumidity();  
// Считывание температуры в цельсиях
  float t = dht.readTemperature();
  
  // проверяем, были ли ошибки при считывании и, если были, начинаем заново
  if (isnan(h) || isnan(t)) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }
  
  if( t < maxTemp ) // если температура в теплице превышает 29 град
  {
     
      digitalWrite(Relay2, HIGH);// включается лампа
  } 
  else 
  {
     digitalWrite(Relay2, LOW); // отключается лампа
    
  }

    if( t > maxTemp ) // если температура в теплице превышает 30 град
  {
     
      digitalWrite(Relay1, HIGH);// включается лампа
  } 
  else 
  {
     digitalWrite(Relay1, LOW); // отключается лампа
    
  }
  Serial.print("Humidity: "); // вывод данных в монитор порта
  Serial.print(h);
  Serial.print(" %\t");
  Serial.print("Temperature: "); 
  Serial.print(t);
  Serial.println(" *C ");
   
  }

2.	Программный код системы автоматического взвешивания и регистрации весы на ПК
#include <SPI.h>
#include <MFRC522.h>
#include "HX711.h"                                            // подключаем библиотеку для работы с тензодатчиком

#define RST_PIN         9
#define SS_PIN          10
#define DT  A0                                                // Указываем номер вывода, к которому подключен вывод DT  датчика
#define SCK A1                                                // Указываем номер вывода, к которому подключен вывод SCK датчика

int row_excel = 0; // количество строк
MFRC522 mfrc522(SS_PIN, RST_PIN);
HX711 scale;                                                  // создаём объект scale
float calibration_factor = 5;                            // вводим калибровочный коэффициент
float units;                                                  // задаём переменную для измерений в граммах
float ounces;                                                 // задаём переменную для измерений в унциях

void setup() {
  pinMode(5, OUTPUT);
  Serial.begin(9600);
  scale.begin(DT, SCK);                     // инициируем работу с датчиком
  scale.set_scale();                              // выполняем измерение значения без калибровочного коэффициента
  scale.tare();                             // сбрасываем значения веса на датчике в 0
  scale.set_scale(calibration_factor);                        // устанавливаем калибровочный коэффициент
  SPI.begin();
  Serial.println("CLEARDATA");                           // очистка листа excel
  Serial.println("Time,Weight,Code");                     // заголовки столбцов
  mfrc522.PCD_Init();
}

void loop() {
for (int i = 0; i < 10; i ++) {                    // усредняем показания, считав значения датчика 10 раз
units = + scale.get_units(), 10;              // суммируем показания 10 замеров
  }
  units = units / 10;                                // усредняем показания, разделив сумму значений на 10
  ounces = units * 0.035274;                // переводим вес из унций в граммы
  
  row_excel++; // номер строки + 1

  MFRC522::MIFARE_Key key;
  for (byte i = 0; i < 6; i++) key.keyByte[i] = 0xFF;

  byte block;
  byte len;
  MFRC522::StatusCode status;

  if ( ! mfrc522.PICC_IsNewCardPresent()) {
    return;
  }

  if ( ! mfrc522.PICC_ReadCardSerial()) {
    return;


  }

Serial.print("DATA,TIME,"); // запись в excel текущей даты и времени
Serial.print(ounces );                                       // выводим в монитор последовательного порта вес в граммах

  mfrc522.PICC_DumpToSerial(&(mfrc522.uid));
  delay(1000); //изменить если необходимо считывать карты быстрее
  mfrc522.PICC_HaltA();
  mfrc522.PCD_StopCrypto1();
  Serial.println(row_excel);
 
}

